             .title      "Action 52 Reader Plugin"


;06/20/00 
;Written by KH
;Version 1.0
             

             ;vectors for standard system calls

send_byte:   .equ 0200h
baton:       .equ 0203h
chk_vram:    .equ 0206h
chk_wram:    .equ 0209h
wr_ppu:      .equ 020ch
read_byte:   .equ 020fh
init_crc:    .equ 0212h
do_crc:      .equ 0215h
finish_crc:  .equ 0218h

crc0:        .equ 0080h
crc1:        .equ 0081h
crc2:        .equ 0082h
crc3:        .equ 0083h

temp1:       .equ 00e0h
temp1_lo:    .equ 00e0h
temp1_hi:    .equ 00e1h
temp2:       .equ 00e2h
temp2_lo:    .equ 00e2h
temp2_hi:    .equ 00e3h

temp3:       .equ 00e4h
temp3_lo:    .equ 00e4h
temp3_hi:    .equ 00e5h

temp4:       .equ 00e6h   ;for wr_bank
temp4_lo:    .equ 00e6h
temp4_hi:    .equ 00e7h
temp5:       .equ 00e8h
temp5_lo:    .equ 00e8h
temp5_hi:    .equ 00e9h
x_temp:      .equ 00eah
y_temp:      .equ 00ebh

temp_crc:    .equ 00ech

;plugin header defines
p_ver: = 1	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Action 52"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "Kevin Horton"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 1536 >> 4,0 >> 4
             .db 512 >> 3,0 >> 3
             .db 0,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here

             lda #04h
             jsr send_byte   ;send byte

;determine CHR ROM size (128K)

chronly:             
             lda #000h
             jsr send_byte
             lda #008h
             jsr send_byte
             lda #002h
             jsr send_byte  ;send chr block

             lda #0
             sta temp2_lo    ;bankswitch ctr
             ldx #040h

dump_it3:    lda temp2_lo
             jsr wr_cbank
             lda #020h
             sta temp1_hi
             ldy #0
             sty 2006h
             sty 2006h
             lda 2007h

dump_it4:    lda 2007h
             jsr send_byte
             iny
             bne dump_it4
             jsr baton
             dec temp1_hi
             bne dump_it4
             inc temp2_lo
             dex
             bne dump_it3



             
             lda #000h
             jsr send_byte
             lda #018h       ;send size
             jsr send_byte
             lda #001h
             jsr send_byte   ;send PRG 
             
             lda #0
             sta temp2_lo    ;bankswitch ctr
             ldx #48         ;48 32K pages(!)

dump_it2:    lda temp2_lo
             jsr wr_pbank
             ldy #0
             sty temp1_lo
             lda #080h
             sta temp1_hi

dump_it:     lda (temp1),y
             jsr send_byte
             iny
             bne dump_it
             jsr baton
             inc temp1_hi
             bne dump_it
             inc temp2_lo
             dex
             bne dump_it2



             
             lda #000h
             jsr send_byte
             lda #000h
             jsr send_byte
             lda #000h
             jsr send_byte  ;send end block
             rts

;6000h - a0-a2 = prg, a3/a4 = chr 2,3
;8000h wr d0,1 = chr 0,1


wr_pbank:    sta temp4_hi
             lda #020h
             bit temp4_hi    ;test upper bit
             beq no_mod
             lda temp4_hi
             ora #010h
             sta temp4_hi

no_mod:      lda #0h
             sta temp4_lo
             sec
             ror temp4_hi
             ror temp4_lo     ;fix up bank bits
             ldy #0
             sta (temp4),y
             rts

wr_cbank:    pha
             lsr a
             lsr a
             sta temp4_lo
             lda #080h
             sta temp4_hi
             pla
             ldy #0
             sta (temp4),y
             rts





             .fill 0800h-*,0ffh   ;fill rest to get 1K of data

;UNIF ROM packaging

             .db "C00800"
             .db "P00800"
             .db "P10800"
             .db "P20800"
             

             .end